// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import type { NextApiRequest, NextApiResponse } from "next";
import { app } from "@/firebase";
import {
  getFirestore,
  collection,
  getDocs,
  getDoc,
  doc,
  deleteDoc,
  setDoc,
} from "firebase/firestore";
import { withIronSessionApiRoute } from "iron-session/next";
import { sessionOptions } from "@/lib/session";
import { Group } from "@/interfaces/user";
import { updateExpiryDateOnGroup } from "@/utils/groups.be";

const db = getFirestore(app);

export default withIronSessionApiRoute(handler, sessionOptions);

async function handler(req: NextApiRequest, res: NextApiResponse) {
  if (req.method === "GET") return await get(req, res);
  if (req.method === "DELETE") return await del(req, res);
  if (req.method === "PATCH") return await patch(req, res);

  res.status(404).json(undefined);
}

async function get(req: NextApiRequest, res: NextApiResponse) {
  if (!req.session.user) {
    res.status(401).json({ ok: false });
    return;
  }

  const { id } = req.query as { id: string };

  const snapshot = await getDoc(doc(db, "groups", id));

  if (snapshot.exists()) {
    res.status(200).json({ ...snapshot.data(), id: snapshot.id });
  } else {
    res.status(404).json(undefined);
  }
}

async function del(req: NextApiRequest, res: NextApiResponse) {
  if (!req.session.user) {
    res.status(401).json({ ok: false });
    return;
  }

  const { id } = req.query as { id: string };

  const snapshot = await getDoc(doc(db, "groups", id));
  const group = { ...snapshot.data(), id: snapshot.id } as Group;

  const user = req.session.user;
  if (
    user.type === "admin" ||
    user.type === "developer" ||
    user.id === group.admin
  ) {
    await deleteDoc(snapshot.ref);

    res.status(200).json({ ok: true });
    return;
  }

  res.status(403).json({ ok: false });
}

async function patch(req: NextApiRequest, res: NextApiResponse) {
  if (!req.session.user) {
    res.status(401).json({ ok: false });
    return;
  }

  const { id } = req.query as { id: string };

  const snapshot = await getDoc(doc(db, "groups", id));
  const group = { ...snapshot.data(), id: snapshot.id } as Group;

  const user = req.session.user;
  if (
    user.type === "admin" ||
    user.type === "developer" ||
    user.id === group.admin
  ) {
    if ("participants" in req.body) {
      const newParticipants = (req.body.participants as string[]).filter(
        (x) => !group.participants.includes(x),
      );
      await Promise.all(
        newParticipants.map(
          async (p) => await updateExpiryDateOnGroup(p, group.admin),
        ),
      );
    }

    await setDoc(snapshot.ref, req.body, { merge: true });

    res.status(200).json({ ok: true });
    return;
  }

  res.status(403).json({ ok: false });
}
